/*
 * Copyright 2009 Arne Vajhj.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

package dk.vajhoej.vms.rms;

/**
 * Class NativeAPI contains all the JNI methods implemented in C.
 */
public class NativeAPI {
    static {
        System.loadLibrary("vmsis_NativeAPI");
    }
    public native static long open(String fnm, boolean readonly);
    public native static int lockByte(long ptr, byte ix, byte k);
    public native static int lockShort(long ptr, byte ix, short k);
    public native static int lockInt(long ptr, byte ix, int k);
    public native static int lockLong(long ptr, byte ix, long k);
    public native static int lockString(long ptr, byte ix, String k);
    public native static int getByte(long ptr, byte ix, byte k, byte[] buf);
    public native static int getShort(long ptr, byte ix, short k, byte[] buf);
    public native static int getInt(long ptr, byte ix, int k, byte[] buf);
    public native static int getLong(long ptr, byte ix, long k, byte[] buf);
    public native static int getString(long ptr, byte ix, String k, byte[] buf);
    public native static int put(long ptr, byte[] buf);
    public native static int update(long ptr, byte[] buf);
    public native static int deleteByte(long ptr, byte ix, byte k);
    public native static int deleteShort(long ptr, byte ix, short k);
    public native static int deleteInt(long ptr, byte ix, int k);
    public native static int deleteLong(long ptr, byte ix, long k);
    public native static int deleteString(long ptr, byte ix, String k);
    public native static int findByte(long ptr, byte ix, byte k, int comp);
    public native static int findShort(long ptr, byte ix, short k, int comp);
    public native static int findInt(long ptr, byte ix, int k, int comp);
    public native static int findLong(long ptr, byte ix, long k, int comp);
    public native static int findString(long ptr, byte ix, String k, int comp);
    public native static int get(long ptr, byte[] buf);
    public native static void close(long ptr);
}
